package de.web.minecraftandi;

import org.bukkit.entity.Player;
import org.bukkit.event.Event.Priority;
import org.bukkit.event.Event;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.plugin.PluginManager;

import com.nijiko.permissions.PermissionHandler;
import com.nijikokun.bukkit.Permissions.Permissions;

/**
 * xLevel Plugin
 * @author Andi
 */
public class xLevel extends JavaPlugin {
    private final xPlayerListener playerListener = new xPlayerListener(this);
    private final xBlockListener blockListener = new xBlockListener(this);
    private final xEntityListener entityListener = new xEntityListener(this);
    private final xCommandListener commandListener = new xCommandListener(this);
    
    public static PermissionHandler permissionHandler;
    
    public void onDisable() {
	    PluginDescriptionFile pdfFile = this.getDescription();

    	if (xConfig.saveCooldowns) xSkillManager.saveData();
    	if (xConfig.saveLastUsedSkill) xSettingsManager.saveData();
	    xDataManager.saveData();
	    
		System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] is disabled!" );
    }
    
    public void onEnable() {
    	PluginDescriptionFile pdfFile = this.getDescription();
        xConfig.startup(this);
        xConfig.initialize(getDataFolder());
        xDataManager.startup(this);
        xDataManager.initialize();
        xSkillManager.startup(this);
        xSkillManager.initialize();
        xSettingsManager.startup(this);
        xSettingsManager.initialize();
        xArcher.startup(this);
        xEffectManager.startup(this);
        
        if(xConfig.usePermissions) {
            Plugin permissionsPlugin = this.getServer().getPluginManager().getPlugin("Permissions");
            if (xLevel.permissionHandler == null) {
                if (permissionsPlugin != null) {
                	System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] Permission found - hooking into Permissions");
                    xLevel.permissionHandler = ((Permissions) permissionsPlugin).getHandler();
                } else {
                	System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] Permission not found - defaulting to OP");
                	xConfig.usePermissions = false;
                }
            }
        } else {
        	System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] Permission disabled by config - defaulting to OP");
        }
        
        PluginManager pm = getServer().getPluginManager();
        pm.registerEvent(Event.Type.PLAYER_JOIN, playerListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.PLAYER_QUIT, playerListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.PLAYER_MOVE, playerListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.PLAYER_RESPAWN, playerListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.PLAYER_INTERACT, playerListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.BLOCK_BREAK, blockListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.BLOCK_PLACE, blockListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.ENTITY_DAMAGE, entityListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.ENTITY_DEATH, entityListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.ENTITY_TARGET, entityListener, Priority.Normal, this);
        pm.registerEvent(Event.Type.PLAYER_COMMAND_PREPROCESS, commandListener, Priority.Highest, this);
        
        System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] is enabled!" );
        
        if (xConfig.saveCooldowns) xSkillManager.loadData();
        if (xConfig.saveLastUsedSkill) xSettingsManager.loadData();
        xDataManager.loadData();

		System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] finished loading!" );
    }
    
    public boolean isOnline(String playername) {
    	Player player = this.getServer().getPlayer(playername);
    	if(player.isOnline()) {
    		return true;
    	} else {
    		return false;
    	}
    }
}
