package de.web.minecraftandi;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.bukkit.event.player.PlayerTeleportEvent;
import org.bukkit.util.Vector;

/**
 * Handle player related events
 * @author Andi
 */
public class xPlayerListener extends PlayerListener {
    private final xLevel plugin;

    public xPlayerListener(xLevel instance) {
        plugin = instance;
    }
    
    public void onPlayerJoin(PlayerJoinEvent event)
    {
    	Player player = event.getPlayer();
    	String playername = player.getName();;
    	
    	if(xDataManager.getData(playername).equalsIgnoreCase("none")) {
			player.sendMessage(ChatColor.YELLOW + "[xLevel Help]");
			player.sendMessage(ChatColor.GRAY + " Welcome new player!");
			player.sendMessage(ChatColor.GRAY + " This server runs xLevel! For more information use" + ChatColor.LIGHT_PURPLE + " /xl help" + ChatColor.GRAY + "!");
    	}
    	
    	xDataManager.NewEntry(playername);
    	xSkillManager.NewEntry(playername);
    	xSettingsManager.NewEntry(playername);
    	
    	if (xConfig.saveCooldowns) xSkillManager.checkSaveData();
    	if (xConfig.saveLastUsedSkill) xSettingsManager.checkSaveData();
    	xDataManager.checkSaveData();
    	
    	Player[] playerlist = plugin.getServer().getOnlinePlayers();
    	for (Player player2 : playerlist) {
	    	if (xEffectManager.getArcherEffectInvisible(player2.getName())) {
	    		if(xConfig.usePermissions) {
		     		if (!xLevel.permissionHandler.has(player2, "xlevel.admin.seeinvisibles")) {
		     			xArcher.setInvisible(player2);
		     		}
	    		}
			}
    	}
    }

    public void onPlayerRespawn(PlayerRespawnEvent event)
    {
    	Player player = event.getPlayer();
    	if (player.getEntityId() == xEntityListener.lastDiedP) {
    		xEntityListener.lastDiedP = -1;
    	}

    	Player[] playerlist = plugin.getServer().getOnlinePlayers();
    	for (Player player2 : playerlist) {
	    	if (xEffectManager.getArcherEffectInvisible(player2.getName())) {
	    		if(xConfig.usePermissions) {
		     		if (!xLevel.permissionHandler.has(player2, "xlevel.admin.seeinvisibles")) {
		     			xArcher.setInvisible(player2);
		     		}
	    		}
			}
    	}
    }
    
    public void onPlayerQuit(PlayerQuitEvent event)
    {
    	Player player = event.getPlayer();
    	String playername = player.getName();
    	
    	if (xEffectManager.getArcherEffectInvisible(playername)) {
    		xArcher.removeInvisible(player);
		}

    	if (xConfig.saveCooldowns) xSkillManager.checkSaveData();
    	if (xConfig.saveLastUsedSkill) xSettingsManager.checkSaveData();
    	xDataManager.checkSaveData();
    }
    
    public void onPlayerTeleport(PlayerTeleportEvent event)
    {
    	Player[] playerlist = plugin.getServer().getOnlinePlayers();
    	for (Player player2 : playerlist) {
	    	if (xEffectManager.getArcherEffectInvisible(player2.getName())) {
	    		if(xConfig.usePermissions) {
		     		if (!xLevel.permissionHandler.has(player2, "xlevel.admin.seeinvisibles")) {
		     			xArcher.setInvisible(player2);
		     		}
	    		}
			}
    	}
    }
    
    public void onPlayerMove(PlayerMoveEvent event)
    {
    	Player player = event.getPlayer();
    	String playername = player.getName();
    	
    	if (xEffectManager.getArcherEffectInvisible(playername)) {
    		Vector oldVector = player.getVelocity();
    		Vector newVector = oldVector.multiply(0.5D);
    		player.setVelocity(newVector);
		}
    	
    	if (xEffectManager.getMagicianEffectIcyWind(playername)) {
    		Vector oldVector = player.getVelocity();
    		Vector newVector = oldVector.multiply(0.5D);
    		player.setVelocity(newVector);
    	}
    	xEffectManager.getMagicianEffectLeavesJail(playername);
    	
    	xEffectManager.getPriestEffectSummonWolves(playername);
    	xEffectManager.getPriestEffectDefBuff(playername);
    	xEffectManager.getPriestEffectStrBuff(playername);
    	if (xEffectManager.getPriestEffectSpeedBuff(playername)) {
    		if (player.isSneaking()) {
    	    	Vector vel = player.getVelocity();
    	    	vel = vel.add(player.getLocation().getDirection().multiply(0.6D).setY(0));
    	    	player.setVelocity(vel);
    		}
    	}
    	
    	xEffectManager.checkArcherEffectFireArrow(playername);
    	xEffectManager.getArcherEffectFireArrow(playername);
    	xEffectManager.checkArcherEffectCriticalArrow(playername);
    	xEffectManager.checkArcherEffectHook(playername);
    	xEffectManager.checkArcherEffectPoisonedArrow(playername);
    	xEffectManager.getArcherEffectPoisonedArrow(playername);

    	if (xEffectManager.getWarriorEffectSprint(playername)) {
    		if (player.isSneaking()) {
    	    	Vector vel = player.getVelocity();
    	    	vel = vel.add(player.getLocation().getDirection().multiply(0.6D).setY(0));
    	    	player.setVelocity(vel);
    		}
    	}

    	if (xEffectManager.checkWarriorEffectCrippling(playername)) {
    		Vector oldVector = player.getVelocity();
    		Vector newVector = oldVector.multiply(0.5D);
    		player.setVelocity(newVector);
    	}
    	
    	if (xConfig.saveCooldowns) xSkillManager.checkSaveData();
    	if (xConfig.saveLastUsedSkill) xSettingsManager.checkSaveData();
    	xDataManager.checkSaveData();
    }
    
    public void onPlayerInteract(PlayerInteractEvent event)
    {
    	Player player = event.getPlayer();
    	String playername = player.getName();
    	
    	if((event.getAction() == Action.LEFT_CLICK_AIR) || (event.getAction() == Action.LEFT_CLICK_BLOCK)) {
    		if ((player.getItemInHand().getType() != Material.FEATHER) && (xEffectManager.getArcherEffectInvisible(playername))) {
    			xArcher.removeInvisible(player);
    		}
    	}
    	
    	if(((event.getAction() == Action.RIGHT_CLICK_AIR)
    				|| (event.getAction() == Action.RIGHT_CLICK_BLOCK))
    				&& (event.getMaterial() == Material.BOOK)) {
    		
    		String playerData = xDataManager.getData(playername);
            if(playerData != "none") {
            	String[] split = playerData.split(" ");
            	if(split.length == 3) {
            		if((split[0].equalsIgnoreCase("Magician"))
            					|| (split[0].equalsIgnoreCase("Priest"))) {
            			
	            		int playerlevel = Integer.parseInt(split[1]);
	            		String playerclass = split[0];
	            		int usedSkill = xSettingsManager.getSettingUsedSkill(playername);
	            		if (playerlevel > 4) {
	            			usedSkill++;
	            			if (usedSkill > 5) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 3) {
	            			usedSkill++;
	            			if (usedSkill > 4) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 2) {
	            			usedSkill++;
	            			if (usedSkill > 3) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 1) {
	            			usedSkill++;
	            			if (usedSkill > 2) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 0) {
	            			usedSkill++;
	            			if (usedSkill > 1) {
	            				usedSkill = 0;
	            			}
	            		}
	            		xSettingsManager.setSettingUsedSkill(playername, usedSkill);
	            		if (usedSkill == 0) {
	                		player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You are now using no skill!");
	            		} else {
	            			String usedSkillName = xSkillManager.getSkillName(playerclass, usedSkill);
	            			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You are now using " + usedSkillName + "!");
	            		}
            		}
            	}
            }
    	} else if(((event.getAction() == Action.RIGHT_CLICK_AIR)
				|| (event.getAction() == Action.RIGHT_CLICK_BLOCK))
				&& (event.getMaterial() == Material.ARROW)) {
		
			String playerData = xDataManager.getData(playername);
	        if(playerData != "none") {
	        	String[] split = playerData.split(" ");
	        	if(split.length == 3) {
	        		if(split[0].equalsIgnoreCase("Archer")) {
	        			
	            		int playerlevel = Integer.parseInt(split[1]);
	            		String playerclass = split[0];
	            		int usedSkill = xSettingsManager.getSettingUsedSkill(playername);
	            		if (playerlevel > 4) {
	            			usedSkill++;
	            			if (usedSkill == 2) {
	            				usedSkill++;
	            			}
	            			if (usedSkill > 5) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 3) {
	            			usedSkill++;
	            			if (usedSkill == 2) {
	            				usedSkill++;
	            			}
	            			if (usedSkill > 4) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 2) {
	            			usedSkill++;
	            			if (usedSkill == 2) {
	            				usedSkill++;
	            			}
	            			if (usedSkill > 3) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 0) {
	            			usedSkill++;
	            			if (usedSkill > 1) {
	            				usedSkill = 0;
	            			}
	            		}
	            		xSettingsManager.setSettingUsedSkill(playername, usedSkill);
	            		if (usedSkill == 0) {
	                		player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You are now using no skill!");
	            		} else {
	            			String usedSkillName = xSkillManager.getSkillName(playerclass, usedSkill);
	            			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You are now using " + usedSkillName + "!");
	            		}
	        		}
	        	}
	        }
    	} else if((event.getAction() == Action.LEFT_CLICK_AIR)
    				&& (event.getMaterial() == Material.STICK)) {
    		
    		String playerData = xDataManager.getData(playername);
            if(playerData != "none") {
            	String[] split = playerData.split(" ");
            	if(split.length == 3) {
	            	if(split[0].equalsIgnoreCase("Magician")) {
	            		int playerlevel = Integer.parseInt(split[1]);
	            		int usedSkill = xSettingsManager.getSettingUsedSkill(playername);
	            		
	            		if ((usedSkill > 0) && (usedSkill < 6)) {
	            			if (xSkillManager.getSkillCanUse(playername, usedSkill)) {
	            				if ((playerlevel > 4) && (usedSkill == 5)) {
	    	            			if (xMagician.skill5(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 3) && (usedSkill == 4)) {
	    	            			if (xMagician.skill4(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 2) && (usedSkill == 3)) {
	    	            			if (xMagician.skill3(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 1) && (usedSkill == 2)) {
	    	            			if (xMagician.skill2(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 0) && (usedSkill == 1)) {
	    	            			if (xMagician.skill1(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		}
	            			} else {
	            				player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You have to wait " + ChatColor.RED + (xSkillManager.getSkillTimeToCanUse(playername, usedSkill) / 1000) + ChatColor.GRAY + " more seconds to cast this skill again!");
	            			}
	            		}
	            	}
            	}
            }
    	} else if((event.getAction() == Action.RIGHT_CLICK_AIR)
    				&& ((event.getMaterial() == Material.WOOD_AXE)
    				|| (event.getMaterial() == Material.STONE_AXE)
    				|| (event.getMaterial() == Material.IRON_AXE)
    				|| (event.getMaterial() == Material.DIAMOND_AXE))) {
    		
    		String playerData = xDataManager.getData(playername);
            if(playerData != "none") {
            	String[] split = playerData.split(" ");
            	if(split.length == 3) {
	            	if(split[0].equalsIgnoreCase("Priest")) {
	            		int playerlevel = Integer.parseInt(split[1]);
	            		int usedSkill = xSettingsManager.getSettingUsedSkill(playername);
	            		
	            		if ((usedSkill > 0) && (usedSkill < 6)) {
	            			if (xSkillManager.getSkillCanUse(playername, usedSkill)) {
	            				if ((playerlevel > 4) && (usedSkill == 5)) {
	    	            			if (xPriest.skill5(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 3) && (usedSkill == 4)) {
	    	            			if (xPriest.skill4(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 2) && (usedSkill == 3)) {
	    	            			if (xPriest.skill3(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 1) && (usedSkill == 2)) {
	    	            			if (xPriest.skill2(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 0) && (usedSkill == 1)) {
	    	            			if (xPriest.skill1(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		}
	            			} else {
	            				player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You have to wait " + ChatColor.RED + (xSkillManager.getSkillTimeToCanUse(playername, usedSkill) / 1000) + ChatColor.GRAY + " more seconds to cast this skill again!");
	            			}
	            		}
	            	}
            	}
            }
    	} else if((event.getAction() == Action.LEFT_CLICK_AIR)
    				&& (event.getMaterial() == Material.BOW)) {
    		
    		String playerData = xDataManager.getData(playername);
            if(playerData != "none") {
            	String[] split = playerData.split(" ");
            	if(split.length == 3) {
	            	if(split[0].equalsIgnoreCase("Archer")) {
	            		int playerlevel = Integer.parseInt(split[1]);
	            		int usedSkill = xSettingsManager.getSettingUsedSkill(playername);
	            		
	            		if ((usedSkill > 0) && (usedSkill < 6)) {
	            			if (xSkillManager.getSkillCanUse(playername, usedSkill)) {
	            				if ((playerlevel > 4) && (usedSkill == 5)) {
	    	            			if (xArcher.skill5(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 3) && (usedSkill == 4)) {
	    	            			if (xArcher.skill4(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 2) && (usedSkill == 3)) {
	    	            			if (xArcher.skill3(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 0) && (usedSkill == 1)) {
	    	            			if (xArcher.skill1(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		}
	            			} else {
	            				player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You have to wait " + ChatColor.RED + (xSkillManager.getSkillTimeToCanUse(playername, usedSkill) / 1000) + ChatColor.GRAY + " more seconds to cast this skill again!");
	            			}
	            		}
	            	}
            	}
            }
    	} else if((event.getAction() == Action.LEFT_CLICK_AIR)
    				&& (event.getMaterial() == Material.FEATHER)) {
    		
    		String playerData = xDataManager.getData(playername);
            if(playerData != "none") {
            	String[] split = playerData.split(" ");
            	if(split.length == 3) {
	            	if(split[0].equalsIgnoreCase("Archer")) {
	            		int playerlevel = Integer.parseInt(split[1]);
	            		
            			if (xSkillManager.getSkillCanUse(playername, 2)) {
            				if (playerlevel > 1) {
    	            			if (xArcher.skill2(event)) {
    	            				if(xConfig.usePermissions) {
    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
    		    	            			xSkillManager.setSkillLastUsed(playername, 2);
    	            					}
    	            				} else if(xConfig.opNoCooldown) {
	            						if (!player.isOp()) {
			    	            			xSkillManager.setSkillLastUsed(playername, 2);
	            						}
    	            				} else {
		    	            			xSkillManager.setSkillLastUsed(playername, 2);
    	            				}
    	            			}
    	            		}
            			} else {
            				player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You have to wait " + ChatColor.RED + (xSkillManager.getSkillTimeToCanUse(playername, 2) / 1000) + ChatColor.GRAY + " more seconds to cast this skill again!");
            			}
	            	}
            	}
            }
    	} else if(((event.getAction() == Action.RIGHT_CLICK_AIR)
    			|| (event.getAction() == Action.RIGHT_CLICK_BLOCK))
    			&& ((event.getMaterial() == Material.WOOD_SWORD)
    			|| (event.getMaterial() == Material.STONE_SWORD)
    			|| (event.getMaterial() == Material.IRON_SWORD)
    			|| (event.getMaterial() == Material.DIAMOND_SWORD))) {
    		
    		String playerData = xDataManager.getData(playername);
            if(playerData != "none") {
            	String[] split = playerData.split(" ");
            	if(split.length == 3) {
	            	if(split[0].equalsIgnoreCase("Warrior")) {
	            		int playerlevel = Integer.parseInt(split[1]);
	            		int usedSkill = xSettingsManager.getSettingUsedSkill(playername);
	            		
	            		if ((usedSkill > 0) && (usedSkill < 6)) {
	            			if (xSkillManager.getSkillCanUse(playername, usedSkill)) {
	            				if ((playerlevel > 4) && (usedSkill == 5)) {
	            					if (!xEffectManager.warriorEffectSkullSplitterPlayer.containsKey(playername)) {
	    	            				if (xWarrior.skill5(event)) {
		    	            				if(xConfig.usePermissions) {
		    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
		    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
		    	            					}
		    	            				} else if(xConfig.opNoCooldown) {
	    	            						if (!player.isOp()) {
	    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            						}
		    	            				} else {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
		    	            				}
		    	            			}
	    	            				player.sendMessage(ChatColor.GRAY + "*** You activated skullsplitter!");
	    	            			} else {
	    	            				player.sendMessage(ChatColor.GRAY + "*** Skullsplitter is still activated!");
	    	            			}
	    	            		} else if ((playerlevel > 2) && (usedSkill == 3)) {
	    	            			if (!xEffectManager.warriorEffectCripplingPlayer.containsKey(playername)) {
	    	            				if (xWarrior.skill3(event)) {
		    	            				if(xConfig.usePermissions) {
		    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
		    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
		    	            					}
		    	            				} else if(xConfig.opNoCooldown) {
	    	            						if (!player.isOp()) {
	    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            						}
		    	            				} else {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
		    	            				}
		    	            			}
	    	            				player.sendMessage(ChatColor.GRAY + "*** You activated crippling!");
	    	            			} else {
	    	            				player.sendMessage(ChatColor.GRAY + "*** Crippling is still activated!");
	    	            			}
	    	            		} else if ((playerlevel > 1) && (usedSkill == 2)) {
	    	            			if (xWarrior.skill2(event)) {
	    	            				if(xConfig.usePermissions) {
	    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
	    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            					}
	    	            				} else if(xConfig.opNoCooldown) {
    	            						if (!player.isOp()) {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
    	            						}
	    	            				} else {
			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            				}
	    	            			}
	    	            		} else if ((playerlevel > 0) && (usedSkill == 1)) {
	    	            			if (!xEffectManager.warriorEffectPushPlayer.containsKey(playername)) {
	    	            				if (xWarrior.skill1(event)) {
		    	            				if(xConfig.usePermissions) {
		    	            					if (!xLevel.permissionHandler.has(player, "xlevel.admin.nocooldown")) {
		    		    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
		    	            					}
		    	            				} else if(xConfig.opNoCooldown) {
	    	            						if (!player.isOp()) {
	    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
	    	            						}
		    	            				} else {
    			    	            			xSkillManager.setSkillLastUsed(playername, usedSkill);
		    	            				}
		    	            			}
	    	            				player.sendMessage(ChatColor.GRAY + "*** You activated push!");
	    	            			} else {
	    	            				player.sendMessage(ChatColor.GRAY + "*** Push is still activated!");
	    	            			}
	    	            		}
	            			} else {
	            				player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You have to wait " + ChatColor.RED + (xSkillManager.getSkillTimeToCanUse(playername, usedSkill) / 1000) + ChatColor.GRAY + " more seconds to cast this skill again!");
	            			}
	            		}
	            	}
            	}
            }
    	} else if(((event.getAction() == Action.RIGHT_CLICK_AIR)
				|| (event.getAction() == Action.RIGHT_CLICK_BLOCK))
				&& (event.getMaterial() == Material.BONE)) {
		
			String playerData = xDataManager.getData(playername);
	        if(playerData != "none") {
	        	String[] split = playerData.split(" ");
	        	if(split.length == 3) {
	        		if(split[0].equalsIgnoreCase("Warrior")) {
	        			
	            		int playerlevel = Integer.parseInt(split[1]);
	            		String playerclass = split[0];
	            		int usedSkill = xSettingsManager.getSettingUsedSkill(playername);
	            		if (playerlevel > 4) {
	            			usedSkill++;
	            			if (usedSkill == 4) {
	            				usedSkill++;
	            			}
	            			if (usedSkill > 5) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 3) {
	            			usedSkill++;
	            			if (usedSkill == 4) {
	            				usedSkill++;
	            			}
	            			if (usedSkill > 4) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 2) {
	            			usedSkill++;
	            			if (usedSkill == 4) {
	            				usedSkill++;
	            			}
	            			if (usedSkill > 3) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 1) {
	            			usedSkill++;
	            			if (usedSkill == 4) {
	            				usedSkill++;
	            			}
	            			if (usedSkill > 2) {
	            				usedSkill = 0;
	            			}
	            		} else if (playerlevel > 0) {
	            			usedSkill++;
	            			if (usedSkill > 1) {
	            				usedSkill = 0;
	            			}
	            		}
	            		xSettingsManager.setSettingUsedSkill(playername, usedSkill);
	            		if (usedSkill == 0) {
	                		player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You are now using no skill!");
	            		} else {
	            			String usedSkillName = xSkillManager.getSkillName(playerclass, usedSkill);
	            			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You are now using " + usedSkillName + "!");
	            		}
	        		}
	        	}
	        }
    	}
    }
}
