package de.web.minecraftandi;

import java.io.*;
import java.util.Scanner;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;

import org.bukkit.plugin.PluginDescriptionFile;

public class xSkillManager {
    private static xLevel plugin;
	private static final String dataFolder = "plugins/xLevel/players/";
	private static double lastTimeSaved = System.currentTimeMillis();
	public static ConcurrentHashMap<String, String> skillDatas = new ConcurrentHashMap<String, String>();
    
    public static void startup(final xLevel plugin) {
    	xSkillManager.plugin = plugin;
    }
	
	public static void initialize() {
		File dataFolder2 = new File(dataFolder);
        if(!dataFolder2.exists()) {
            dataFolder2.mkdirs();
        }
	}
	
	public static void NewEntry(String playername) {
		if (!skillDatas.containsKey(playername)) {
			skillDatas.put(playername, "0 0 0 0 0");
		}
	}
	
	public static void loadData() {
		File folder = new File(dataFolder);
		File[] fileList = folder.listFiles();
		
		PluginDescriptionFile pdfFile = plugin.getDescription();
		System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] loading cooldowns..." );

		int entries = 0;
		
		for (int i = 0; i < fileList.length; i++) {
			String fileName = fileList[i].getName();
			String[] split = fileName.split("\\.");
			if (split.length == 2) {
				if (fileName.endsWith(".cooldowns") || fileName.endsWith(".COOLDOWNS")) {
					try {
						Scanner scan = new Scanner(fileList[i]);
						String playerData = "none";
						if (scan.hasNextLine()) {
							playerData = scan.nextLine();
				        }
				        scan.close();
				        if (!playerData.equalsIgnoreCase("none")) {
				        	skillDatas.put(split[0], playerData);
				        	entries++;
				        }
					} catch(IOException ex) {
						ex.printStackTrace();
					}
				}
			}
		}
		
		System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] loaded " + entries + " cooldowns entries!" );
	}
	
	public static String getData(String playername) {
		if (skillDatas.containsKey(playername)) {
			return (String)skillDatas.get(playername);
		}
		return "none";
	}
	
	public static String getSkillLastUsed(String playername, int skill) {
        String skillData = "none";
		String lastUsed = "0";
        skill--;
        
		if (skillDatas.containsKey(playername)) {
			skillData = skillDatas.get(playername);
			String[] split = skillData.split(" ");
			if(split.length == 5) {
				lastUsed = split[skill];
			}
        }
        
		return lastUsed;
	}
	
	public static void setSkillLastUsed(String playername, int skill) {
        if (skillDatas.containsKey(playername)) {
        	String skillData = skillDatas.get(playername);
			String[] split = skillData.split(" ");
			if(split.length == 5) {
		        long now = System.currentTimeMillis();
		        switch (skill) {
		        	case 1:
		        		xSkillManager.setData(playername, now + " " + split[1] + " " + split[2] + " " + split[3] + " " + split[4]);
		        		break;
		        	case 2:
		        		xSkillManager.setData(playername, split[0] + " " + now + " " + split[2] + " " + split[3] + " " + split[4]);
		        		break;
		        	case 3:
		        		xSkillManager.setData(playername, split[0] + " " + split[1] + " " + now + " " + split[3] + " " + split[4]);
		        		break;
		        	case 4:
		        		xSkillManager.setData(playername, split[0] + " " + split[1] + " " + split[2] + " " + now + " " + split[4]);
		        		break;
		        	case 5:
		        		xSkillManager.setData(playername, split[0] + " " + split[1] + " " + split[2] + " " + split[3] + " " + now);
		        		break;
		        }
			}
        }
	}
	
	public static void setSkillLastUsed(String playername, int skill, long time) {
		if (skillDatas.containsKey(playername)) {
        	String skillData = skillDatas.get(playername);
			String[] split = skillData.split(" ");
			if(split.length == 5) {
		        switch (skill) {
		        	case 1:
		        		xSkillManager.setData(playername, time + " " + split[1] + " " + split[2] + " " + split[3] + " " + split[4]);
		        		break;
		        	case 2:
		        		xSkillManager.setData(playername, split[0] + " " + time + " " + split[2] + " " + split[3] + " " + split[4]);
		        		break;
		        	case 3:
		        		xSkillManager.setData(playername, split[0] + " " + split[1] + " " + time + " " + split[3] + " " + split[4]);
		        		break;
		        	case 4:
		        		xSkillManager.setData(playername, split[0] + " " + split[1] + " " + split[2] + " " + time + " " + split[4]);
		        		break;
		        	case 5:
		        		xSkillManager.setData(playername, split[0] + " " + split[1] + " " + split[2] + " " + split[3] + " " + time);
		        		break;
		        }
			}
        }
	}
	
	public static long getSkillGetTimeDiverse(String playername, int skill) {
        long timeDiverse = 0;
        
        long now = System.currentTimeMillis();
        long lastUsed = Long.parseLong(xSkillManager.getSkillLastUsed(playername, skill));
        
        timeDiverse = now - lastUsed;
        
		return timeDiverse;
	}
	
	public static boolean getSkillCanUse(String playername, int skill) {
        long timeDiverse = 0;
        boolean canUse = false;
        
        timeDiverse = xSkillManager.getSkillGetTimeDiverse(playername, skill);
        
        String playerData = xDataManager.getData(playername);
        if(playerData != "none") {
        	String[] split = playerData.split(" ");
        	if(split.length == 3) {
        		int playerlevel = Integer.parseInt(split[1]);
        		if(split[0].equalsIgnoreCase("Archer")) {
        			switch(skill) {
        				case 1:
        					if (playerlevel >= 6) {
        						if (timeDiverse >= 25000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 35000) {
            						canUse = true;
            					}
        					}
	    					break;
	    				case 2:
        					if (playerlevel >= 7) {
        						if (timeDiverse >= 15000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 20000) {
            						canUse = true;
            					}
        					}
	    					break;
	    				case 3:
        					if (playerlevel >= 8) {
        						if (timeDiverse >= 15000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 20000) {
            						canUse = true;
            					}
        					}
	    					break;
	    				case 4:
        					if (playerlevel >= 9) {
        						if (timeDiverse >= 30000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 45000) {
            						canUse = true;
            					}
        					}
	    					break;
	    				case 5:
        					if (playerlevel >= 10) {
        						if (timeDiverse >= 25000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 35000) {
            						canUse = true;
            					}
        					}
	    					break;
        			}
        		}
        		
        		if(split[0].equalsIgnoreCase("Warrior")) {
        			switch(skill) {
    				case 1:
    					if (playerlevel >= 6) {
    						if (timeDiverse >= 15000) {
        						canUse = true;
        					}
    					} else {
    						if (timeDiverse >= 20000) {
        						canUse = true;
        					}
    					}
    					break;
    				case 2:
    					if (playerlevel >= 7) {
    						if (timeDiverse >= 45000) {
        						canUse = true;
        					}
    					} else {
    						if (timeDiverse >= 60000) {
        						canUse = true;
        					}
    					}
    					break;
    				case 3:
    					if (playerlevel >= 8) {
    						if (timeDiverse >= 20000) {
        						canUse = true;
        					}
    					} else {
    						if (timeDiverse >= 30000) {
        						canUse = true;
        					}
    					}
    					break;
    				case 5:
    					if (playerlevel >= 10) {
    						if (timeDiverse >= 30000) {
        						canUse = true;
        					}
    					} else {
    						if (timeDiverse >= 40000) {
        						canUse = true;
        					}
    					}
    					break;
        			}
        		}
        		
        		if(split[0].equalsIgnoreCase("Magician")) {
        			switch(skill) {
	    				case 1:
        					if (playerlevel >= 6) {
        						if (timeDiverse >= 3000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 6000) {
            						canUse = true;
            					}
        					}
	    					break;
	    				case 2:
        					if (playerlevel >= 7) {
        						if (timeDiverse >= 30000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 40000) {
            						canUse = true;
            					}
        					}
	    					break;
	    				case 3:
        					if (playerlevel >= 8) {
        						if (timeDiverse >= 12000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 20000) {
            						canUse = true;
            					}
        					}
	    					break;
	    				case 4:
        					if (playerlevel >= 9) {
        						if (timeDiverse >= 30000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 40000) {
            						canUse = true;
            					}
        					}
	    					break;
	    				case 5:
        					if (playerlevel >= 10) {
        						if (timeDiverse >= 35000) {
            						canUse = true;
            					}
        					} else {
        						if (timeDiverse >= 45000) {
            						canUse = true;
            					}
        					}
	    					break;
	    			}
        		}
        		
        		if(split[0].equalsIgnoreCase("Priest")) {
        			switch(skill) {
    				case 1:
    					if (playerlevel >= 6) {
    						if (timeDiverse >= 15000) {
        						canUse = true;
        					}
    					} else {
    						if (timeDiverse >= 20000) {
        						canUse = true;
        					}
    					}
    					break;
    				case 2:
    					if (playerlevel >= 7) {
    						if (timeDiverse >= 30000) {
        						canUse = true;
        					}
    					} else {
    						if (timeDiverse >= 45000) {
        						canUse = true;
        					}
    					}
    					break;
    				case 3:
    					if (playerlevel >= 8) {
    						if (timeDiverse >= 60000) {
        						canUse = true;
        					}
    					} else {
    						if (timeDiverse >= 90000) {
        						canUse = true;
        					}
    					}
    					break;
    				case 4:
    					if (playerlevel >= 9) {
    						if (timeDiverse >= 60000) {
        						canUse = true;
        					}
    					} else {
    						if (timeDiverse >= 90000) {
        						canUse = true;
        					}
    					}
    					break;
    				case 5:
    					if (playerlevel >= 10) {
    						if (timeDiverse >= 60000) {
        						canUse = true;
        					}
    					} else {
    						if (timeDiverse >= 90000) {
        						canUse = true;
        					}
    					}
    					break;
	    			}
        		}
        	}
        }
        
		return canUse;
	}
	
	public static long getSkillTimeToCanUse(String playername, int skill) {
        long timeDiverse = 0;
        long timeToCanUse = 0;
        
        timeDiverse = xSkillManager.getSkillGetTimeDiverse(playername, skill);
        
        String playerData = xDataManager.getData(playername);
        if(playerData != "none") {
        	String[] split = playerData.split(" ");
        	if(split.length == 3) {
        		int playerlevel = Integer.parseInt(split[1]);
        		if(split[0].equalsIgnoreCase("Archer")) {
        			switch(skill) {
	    				case 1:
	    					if (playerlevel >= 6) {
	    						timeToCanUse = 25000 - timeDiverse;
	    					} else {
	    						timeToCanUse = 35000 - timeDiverse;
	    					}
	    					break;
	    				case 2:
	    					if (playerlevel >= 7) {
	    						timeToCanUse = 15000 - timeDiverse;
	    					} else {
	    						timeToCanUse = 20000 - timeDiverse;
	    					}
	    					break;
	    				case 3:
	    					if (playerlevel >= 8) {
	    						timeToCanUse = 15000 - timeDiverse;
	    					} else {
	    						timeToCanUse = 20000 - timeDiverse;
	    					}
	    					break;
	    				case 4:
	    					if (playerlevel >= 9) {
	    						timeToCanUse = 30000 - timeDiverse;
	    					} else {
	    						timeToCanUse = 45000 - timeDiverse;
	    					}
	    					break;
	    				case 5:
	    					if (playerlevel >= 10) {
	    						timeToCanUse = 25000 - timeDiverse;
	    					} else {
	    						timeToCanUse = 35000 - timeDiverse;
	    					}
	    					break;
        			}
        		}
        		
        		if(split[0].equalsIgnoreCase("Warrior")) {
        			switch(skill) {
	        			case 1:
	    					if (playerlevel >= 6) {
	    						timeToCanUse = 15000 - timeDiverse;
	    					} else {
	    						timeToCanUse = 20000 - timeDiverse;
	    					}
	    					break;
	    				case 2:
	    					if (playerlevel >= 7) {
	    						timeToCanUse = 45000 - timeDiverse;
	    					} else {
	    						timeToCanUse = 60000 - timeDiverse;
	    					}
	    					break;
	    				case 3:
	    					if (playerlevel >= 8) {
	    						timeToCanUse = 20000 - timeDiverse;
	    					} else {
	    						timeToCanUse = 30000 - timeDiverse;
	    					}
	    					break;
	    				case 5:
	    					if (playerlevel >= 10) {
	    						timeToCanUse = 30000 - timeDiverse;
	    					} else {
	    						timeToCanUse = 40000 - timeDiverse;
	    					}
	    					break;
        			}
        		}
        		
        		if(split[0].equalsIgnoreCase("Magician")) {
        			switch(skill) {
	    				case 1:
        					if (playerlevel >= 6) {
        						timeToCanUse = 3000 - timeDiverse;
        					} else {
        						timeToCanUse = 5000 - timeDiverse;
        					}
	    					break;
	    				case 2:
        					if (playerlevel >= 7) {
        						timeToCanUse = 30000 - timeDiverse;
        					} else {
        						timeToCanUse = 40000 - timeDiverse;
        					}
	    					break;
	    				case 3:
        					if (playerlevel >= 8) {
        						timeToCanUse = 12000 - timeDiverse;
        					} else {
        						timeToCanUse = 20000 - timeDiverse;
        					}
	    					break;
	    				case 4:
        					if (playerlevel >= 9) {
        						timeToCanUse = 30000 - timeDiverse;
        					} else {
        						timeToCanUse = 40000 - timeDiverse;
        					}
	    					break;
	    				case 5:
        					if (playerlevel >= 10) {
        						timeToCanUse = 35000 - timeDiverse;
        					} else {
        						timeToCanUse = 45000 - timeDiverse;
        					}
	    					break;
	    			}
        		}
        		
        		if(split[0].equalsIgnoreCase("Priest")) {
        			switch(skill) {
    				case 1:
    					if (playerlevel >= 6) {
    						timeToCanUse = 15000 - timeDiverse;
    					} else {
    						timeToCanUse = 20000 - timeDiverse;
    					}
    					break;
    				case 2:
    					if (playerlevel >= 7) {
    						timeToCanUse = 30000 - timeDiverse;
    					} else {
    						timeToCanUse = 45000 - timeDiverse;
    					}
    					break;
    				case 3:
    					if (playerlevel >= 8) {
    						timeToCanUse = 60000 - timeDiverse;
    					} else {
    						timeToCanUse = 90000 - timeDiverse;
    					}
    					break;
    				case 4:
    					if (playerlevel >= 9) {
    						timeToCanUse = 60000 - timeDiverse;
    					} else {
    						timeToCanUse = 90000 - timeDiverse;
    					}
    					break;
    				case 5:
    					if (playerlevel >= 10) {
    						timeToCanUse = 60000 - timeDiverse;
    					} else {
    						timeToCanUse = 90000 - timeDiverse;
    					}
    					break;
	    			}
        		}
        	}
        }
        
		return timeToCanUse;
	}
	
	public static void setData(String playername,String playerDataSet) {
		skillDatas.put(playername, playerDataSet);
	}
	
	public static void resetAll(String playername) {
		skillDatas.put(playername, "0 0 0 0 0");
	}
	
	public static String getSkillName(String playerclass, int skill) {
		if (playerclass.equals("Archer")) {
			switch (skill) {
				case 1:
					return "fire arrow";
				case 2:
					return "invisibility";
				case 3:
					return "critical arrow";
				case 4:
					return "hook";
				case 5:
					return "poisoned arrow";
			}
		}
		if (playerclass.equals("Warrior")) {
			switch (skill) {
				case 1:
					return "push";
				case 2:
					return "sprint";
				case 3:
					return "crippling";
				case 4:
					return "block";
				case 5:
					return "skullsplitter";
			}
		}
		if (playerclass.equals("Magician")) {
			switch (skill) {
				case 1:
					return "energy wave";
				case 2:
					return "teleport";
				case 3:
					return "icy wind";
				case 4:
					return "leaves jail";
				case 5:
					return "lightning strike";
			}
		}
		if (playerclass.equals("Priest")) {
			switch (skill) {
				case 1:
					return "heal";
				case 2:
					return "summon wolves";
				case 3:
					return "defense buff";
				case 4:
					return "strength buff";
				case 5:
					return "speed buff";
			}
		}
		return "ERROR";
	}
	
	public static void saveData() {
		Set<String> keys = skillDatas.keySet();
		String[] strKeys = keys.toArray(new String[keys.size()]);
		
		for (int i = 0; i < strKeys.length; i++) {
			if (skillDatas.containsKey(strKeys[i])) {
				try {
					File dataFile = new File(dataFolder + strKeys[i] + ".COOLDOWNS");
			        
		        	dataFile.createNewFile();
			        FileWriter fw = new FileWriter(dataFile);
	        		fw.write(skillDatas.get(strKeys[i]));
	        		fw.close();
				} catch(IOException ex) {
					ex.printStackTrace();
				}
			}
		}
		
		PluginDescriptionFile pdfFile = plugin.getDescription();
		if (xConfig.logSaving) {
			System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] saved skilldata!" );
		}
	}

	public static void checkSaveData() {
		double now = System.currentTimeMillis();
		double timeDiverse = now - lastTimeSaved;
		
		if (timeDiverse >= (double)(xConfig.saveInterval*1000)) {
			lastTimeSaved = System.currentTimeMillis();
			saveData();
		}
	}
}
